Drone = {};
Drone._NAME			= "Drone"

function Drone.prerequisitesPresent(specializations)
	return true;
	end;

function Drone.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "mouseEvent", Drone.mouseEvent)
    SpecializationUtil.registerFunction(vehicleType, "activateFlightMode", Drone.activateFlightMode)
    SpecializationUtil.registerFunction(vehicleType, "deactivateFlightMode", Drone.deactivateFlightMode)
    SpecializationUtil.registerFunction(vehicleType, "getMorldDirectionDegree", Drone.getMorldDirectionDegree)
    SpecializationUtil.registerFunction(vehicleType, "getMorldDirectionDegree2", Drone.getMorldDirectionDegree2)
    SpecializationUtil.registerFunction(vehicleType, "getMorldDirectionDegree3", Drone.getMorldDirectionDegree3)
    SpecializationUtil.registerFunction(vehicleType, "getAltitude", Drone.getAltitude)
    SpecializationUtil.registerFunction(vehicleType, "getTailForce", Drone.getTailForce)
    SpecializationUtil.registerFunction(vehicleType, "updateMovement", Drone.updateMovement)
end;

function Drone.registerEventListeners(vehicleType)
	for _, functionName in pairs( { "onLoad", "onUpdate", "onDraw"} ) do
		SpecializationUtil.registerEventListener(vehicleType, functionName, Drone);
	end;
end;

function Drone:onLoad(savegame)
    self.isSelectable = true;
	self.Drone = {};
    if name == nil then name = "UnknownVehicle"; end;

    self.Drone.id = Drone._NAME;
    self.Drone.name = name;
    self.Drone.move = false;
    self.Drone.active = false;
    self.Drone.downForce = 0;
    self.Drone.yForce = 0;
    self.Drone.pitch = 0;
    self.Drone.sendPitch = 0;
    self.Drone.startTimer = 0;
    self.Drone.DroneFlag = self:getNextDirtyFlag();
    self.Drone.lastDigitalSide = 0;
end;

function Drone:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Drone:activateFlightMode()
	local component = self.components[1]
    local massresult = self:getTotalMass(true)
		setLinearDamping(component.node, 0.15);
		setAngularDamping(component.node, 0.01);
		self.Drone.downForce = massresult * -9.81; 
        self.massresult = massresult *1000;
		self.yForce = self.Drone.downForce * -5;
end;

function Drone:deactivateFlightMode()
	local component = self.components[1]
		setLinearDamping(component.node, 0.0); 
		setAngularDamping(component.node, 0.01);
		self.Drone.downForce = self:getTotalMass(true) * -9.81;
		self.yForce = 0;
end;

function Drone:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
    local massresult = (self:getTotalMass(false)) * 1000
        self.massresult = massresult

    local component = self.components[1]
    local altAboveGround, altAboveNN = self.getAltitude(component.node); 
	
    if self.getIsMotorStarted and altAboveGround < 4 then
    else
    end;
    if self.getIsMotorStarted and altAboveGround < 9 then
    else
    end;

    if self.spec_motorized.isMotorStarted and self.spec_enterable.isEntered then
        if not self.Drone.active then
            self.Drone.startTimer = self.Drone.startTimer + dt;
            if self.Drone.startTimer > 9000 then
                Drone.activateFlightMode(self);
                self.Drone.active = true;
                self.wiper = true;
                self.Drone.startTimer = 0;
            end;
        end;
    elseif self.Drone.active then
        Drone.deactivateFlightMode(self);
        self.Drone.active = false;
        self.wiper = false;
    end;
    if not self.Drone.active then return end; 
local collectiveup = getInputAxis(10, 0);
local collectivedown = getInputAxis(11, 0);
local gamepads = getNumOfGamepads();
self.normalizedCollectiveUp = (collectiveup - (-1)) / (1 - (-1));
self.normalizedCollectiveDown = (collectivedown - (-1)) / (1 - (-1));
Drone.updateMovement(self, dt);
    if self.isActive and isActiveForInput then
		if gamepads>0 then
			if collectiveup <= 1 or collectivedown <= 1 then
            if collectiveup < 1 then
                self.Drone.pitch = math.min(self.Drone.pitch + 1/self.normalizedCollectiveUp/3, self.Drone.downForce * -0.85);
            end;
            if collectivedown < 1 then
                self.Drone.pitch = math.max(self.Drone.pitch - 1/self.normalizedCollectiveDown/5, -25.02);
            end;
			end;
		end;

if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT) or Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT)then
            if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT)then
                self.Drone.pitch = math.min(self.Drone.pitch + 3, 15);
            end;
            if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT)then
                self.Drone.pitch = math.max(self.Drone.pitch - 3, -20); 
            end;
       elseif self.Drone.pitch ~= 0 then
if collectiveup == 1 and collectivedown == 1 then 
              self.Drone.pitch = 0; 
           end; 
        end;
	end;
        if self.Drone.pitch ~= self.Drone.sendPitch then
            if not g_server then
                self:raiseDirtyFlags(self.DroneFlag);
            end;
            self.Drone.sendPitch = self.Drone.pitch;
        end;
        if self.Drone.pitch ~= self.Drone.sendPitch then
            if not g_server then
                self:raiseDirtyFlags(self.DroneFlag);
            end;
            self.Drone.sendPitch = self.Drone.pitch;
        end;
    if self.isServer then
        local dX,dY,dZ = localDirectionToWorld(component.node, 1, 0, 0);
        local sinDir = dX / 15;
        local cosDir = dZ / -15;
        self.sd = 150;
        if self.spec_motorized.getIsMotorStarted then
            self.sd = 150; 
        end;
        local zSteer = self.sd * self.spec_drivable.axisForward;
        local xForce = zSteer * cosDir;
        local zForce = zSteer * sinDir;
        if self.spec_drivable.axisForward == 1 or self.spec_drivable.axisForward == -1 or self.spec_drivable.lastDigitalForward == 1 or self.spec_drivable.lastDigitalForward == -1  then
            dg = 0.03; 
        else
            dg = 0; 
        end;
        local component = self.components[1]
                self.Drone.yForce = (self.Drone.pitch + self.Drone.downForce * -0.84222);
                addForce(component.node, xForce, self.Drone.yForce,  zForce, 0, dg, 0, true); 
        local yTurnSpeed = 0;
        if self.spec_drivable.axisSide > 0.1 or self.spec_drivable.axisSide < -0.1 or self.spec_drivable.lastDigitalSide > 0.1 or self.spec_drivable.lastDigitalSide < -0.1  then
            if InputBinding.getIsAnalogInput then
                yTurnSpeed = self.spec_drivable.axisSide * -0.81;
            else
                yTurnSpeed = self.spec_drivable.lastDigitalSide * -0.81;
            end;
        end;

        local AVx, AVy, AVz = getAngularVelocity(component.node);
        if yTurnSpeed == 0 then
           yTurnSpeed = AVy * 0.85;
        end;
        setAngularVelocity(component.node, AVx * 0.75, yTurnSpeed, AVz * 0.75);
        self.yLV = getLinearVelocity(component.node);
        if self.getIsActive and self.getIsTurnedOn then
            local altAboveGround = self.getAltitude(component.node);
            local addw = altAboveGround*6.5;
            local addh = altAboveGround/5;
            local addz = (altAboveGround/2) + (self.lastSpeed * 3850/50);
        end;
    end;
end;

function Drone:getMorldDirectionDegree(rootNode)
    local dX,dY,dZ = localDirectionToWorld(rootNode, 0, 0, 1);
    local sinus = dX / 1;
    local cosinus = dZ / 1;
    local direction = math.deg(math.atan2(sinus, cosinus));
    return direction, sinus, cosinus;
end;

function Drone:getMorldDirectionDegree2(rootNode)
    local dX,dY,dZ = localDirectionToWorld(rootNode, 0, 0, 1);
    local sinus = dX / 1;
    local cosinus = dZ / 1;
    local direction = math.deg(math.atan2(cosinus, sinus));
    return direction, sinus, cosinus;
end;

function Drone:getMorldDirectionDegree3(rootNode)
    local dX,dY,dZ = localDirectionToWorld(rootNode, 0, 0, -1);
    local sinus = dX / 1;
    local cosinus = dZ / 1;
    local direction = math.deg(math.atan2(cosinus, sinus));
    return direction, sinus, cosinus;
end;

function Drone:getAltitude(rootNode)
    local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, getWorldTranslation(self));
    local x, altAboveNN = getWorldTranslation(self);
    local altAboveGround = altAboveNN - terrainHeight;
    if altAboveGround < 0 then altAboveGround = 0.0 end; 
    return altAboveGround, altAboveNN, terrainHeight;
end;

function Drone:getTailForce(rootNode, xSteer)
        local dX,dY,dZ = localDirectionToWorld(self, 0, 0, -1);
        local sinDir = dX / 1;
        local cosDir = dZ / 1;
        local xBackward = 10 * sinDir;
        local zBackward = 10 * cosDir;

        dX,dY,dZ = localDirectionToWorld(rootNode, 1, 0, 0);
        sinDir = dX / 1;
        cosDir = dZ / 1;
        local xTurnForce = xSteer * sinDir;
        local zTurnForce = xSteer * cosDir;

    return xTurnForce, 0, zTurnForce, xBackward, 0.6, zBackward
end;

function Drone:updateMovement(dt)
self.axisSideIsAnalog = InputBinding.getIsAnalogInput
self.axisForwardIsAnalog = InputBinding.getIsAnalogInput
		if not self.getIsEntered then return; end
		local axisAccelerate = self.spec_drivable.lastInputValues.axisAccelerate                 
		local axisBrake = self.spec_drivable.lastInputValues.axisBrake
		local axisForward = MathUtil.clamp((axisAccelerate - axisBrake)*0.5, -1, 1);
		
		if InputBinding.isAxisZero(axisForward) then
			axisAccelerate = self.spec_drivable.lastInputValues.axisAccelerate
			axisBrake = self.spec_drivable.lastInputValues.axisBrake
			self.axisForward = MathUtil.clamp((axisAccelerate - axisBrake)*0.5, -1, 1);
fetch = self.axisForward
        if not InputBinding.isAxisZero(self.axisForward) then
            self.axisForwardIsAnalog = true;
        end
        self.lastDigitalForward = 0;
    end
    self.axisSide = self.spec_drivable.lastInputValues.axisSide
    if InputBinding.isAxisZero(self.axisSide) then
        self.axisSide = self.spec_drivable.lastInputValues.axisSide
        if not InputBinding.isAxisZero(self.axisSide) then
            self.axisSideIsAnalog = true;
        end
        self.lastDigitalSide = 0;
    else
        self.axisSide = MathUtil.clamp(self.lastDigitalSide + dt/self.axisSmoothTime*self.axisSide, -1, 1);
        self.axisSideIsAnalog = false;
        self.lastDigitalSide = self.axisSide;
    end;

     if not self.getIsActiveForInput then
        if not self.axisSideIsAnalog then
            self.axisSide = 0;
        end
        if not self.axisForwardIsAnalog then
            self.axisForward = 0;
        end
    end;
    if not g_server then
        self:raiseDirtyFlags(self.DroneFlag);
    end;
end;

function Drone:onDraw()
    local component = self.components[1]
    local wsad = g_i18n.modEnvironments.FS22_DJI_MAVIC2.texts.teclado
	local updo = g_i18n.modEnvironments.FS22_DJI_MAVIC2.texts.raton
   
    if self.spec_enterable.getIsEntered then

        setTextAlignment(RenderText.ALIGN_CENTER);
        setTextColor(1,1,1,1);
        if self.Drone.active then
		    renderText(0.87, 0.29, 0.016, wsad);
			renderText(0.87, 0.27, 0.016, updo);
            setTextBold(false);
        end;

        setTextAlignment(RenderText.ALIGN_CENTER);
        setTextColor(1,1,1,1);
    end;

end;